﻿var Refresh = 1000; //refreshtime in ms
// CPU
var CPU_perc = 0;
var CPU_total = 0;
var CPU_count = System.Machine.CPUs.count;
var CPU = new Array();
// RAM
var RAM_total = 0;
var RAM_used = 0;
// NET
var NET_ok = true;
var NET_count = 0;
var NET_recv = new Array(); 
var NET_recv_perc = 0;
var NET_recv_tot = 0;
var NET_sent = new Array();  
var NET_sent_perc = 0;
var NET_sent_tot = 0;
//register network library
var dllCLSID = "{25815CC0-43F4-3C75-8C3A-A139D9ADE740}";
var oShell = new ActiveXObject("WScript.Shell");
var gadgetPath = System.Gadget.path;
var charbackslash = new RegExp("\\\\", "g");
var NetLib, regRoot;
if (!ActiveNetLib("HKCU")) {	
	if (!ActiveNetLib("HKLM"))
		NET_ok = false;
}

function StartMonitor() 
{
    document.body.style.width = 130;
    document.body.style.height= 60;
	document.body.style.margin=0;

    for (var i=0;i<=CPU_count;i++)
	{
	  CPU[i]=0;
	}

	if(NET_ok)
	{
		NET_count = NetLib.Initialize();
	    for (var i=0;i<=NET_count;i++)
		{
			NET_recv[i] = 0;
			NET_sent[i] = 0;
		}
	}
	
    onTimer();
    setInterval("onTimer()",1000);
}

function StopMonitor()
{
	try{NetLib.Terminate()} catch(err) {debugLog("Can't dispose of NetLib variables")}
	NetLib = null;
	UnregisterNetLib();
}

function onTimer()
{
    Update();
    RefreshDisplay();
}

function Update()
{
	CPU_total = 0;
    for (var i=0; i<CPU_count; i++)
	{
		CPU[i] = parseInt(System.Machine.CPUs.item(i).usagePercentage);		
		CPU_total += CPU[i];
	}	
	CPU_perc = Math.min(Math.max(0, CPU_total / CPU_count), 100);

	RAM_total = parseInt(System.Machine.totalMemory);
	RAM_available = parseInt(System.Machine.availableMemory);
	if((RAM_total > 0) && (RAM_total > RAM_available))
	{
		RAM_perc = Math.min(100 - (RAM_available / RAM_total * 100), 100);
	}
	else
	{
		RAM_perc = 0;
	}  

	try
	{
		NET_recv_perc = 0;
		NET_sent_perc = 0;
		for (var i=0;i<NET_count;i++)
		{
		    var Recv = parseInt(NetLib.BytesReceived(i));
			var Sent = parseInt(NetLib.BytesSent(i));
			var DiffRecv = Recv - NET_recv[i];
			var DiffSent = Sent - NET_sent[i];
			NET_recv[i]=Recv;
			NET_sent[i]=Sent;
			NET_recv_tot += DiffRecv;
			NET_sent_tot += DiffSent;
			if (DiffRecv > 1024)
			{
				NET_recv_perc = 100;
			}
			if (DiffSent > 1024)
			{
				NET_sent_perc = 100; 
			}
		}
		
	} catch(err) {}
}

function RefreshDisplay()
{
    if(Math.round(CPU_perc) < 10)
	{
		CPU_used_out.innerText = "0" + Math.round(CPU_perc) + "%"; 
	}
	else
	{
		CPU_used_out.innerText = Math.round(CPU_perc) + "%"; 	
	}
	CPU_bar.style.width = parseInt( 0.5 * Math.round(CPU_perc) );
	
    if(Math.round(RAM_perc)<10)
	{
		RAM_used_out.innerText = "0" + Math.round(RAM_perc) + "%"; 
	}
	else
	{
		RAM_used_out.innerText = Math.round(RAM_perc) + "%"; 	
	}
	RAM_bar.style.width = parseInt( 0.5 * Math.round(RAM_perc) );

	NET_recv_bar.style.width = parseInt( 0.2 * Math.round(NET_recv_perc) );
	NET_sent_bar.style.width = parseInt( 0.2 * Math.round(NET_sent_perc) );

	if(NET_recv_tot<=1024)
	{
		NET_recv_total.innerText = parseInt(NET_recv_tot/1024) + "b";
	}
	if(NET_recv_tot>1024)
	{
		NET_recv_total.innerText = parseInt(NET_recv_tot/1024) + "K";
	}
	if(NET_recv_tot>1024*1024)
	{
		NET_recv_total.innerText = parseInt(NET_recv_tot/(1024*1024)) + "M";
	}
	if(NET_recv_tot>1024*1024*1024)
	{
		NET_recv_total.innerText = parseInt(NET_recv_tot/(1024*1024*1024)) + "G";
	}
	if(NET_recv_tot>1024*1024*1024*1024)
	{
		NET_recv_total.innerText = parseInt(NET_recv_tot/(1024*1024*1024*1024)) + "T";
	}
	
	if(NET_sent_tot<=1024)
	{
		NET_sent_total.innerText = parseInt(NET_sent_tot/1024) + "b";
	}
	if(NET_sent_tot>1024)
	{
		NET_sent_total.innerText = parseInt(NET_sent_tot/1024) + "K";
	}
	if(NET_sent_tot>1024*1024)
	{
		NET_sent_total.innerText = parseInt(NET_sent_tot/(1024*1024)) + "M";
	}
	if(NET_sent_tot>1024*1024*1024)
	{
		NET_sent_total.innerText = parseInt(NET_sent_tot/(1024*1024*1024)) + "G";
	}
	if(NET_sent_tot>1024*1024*1024*1024)
	{
		NET_sent_total.innerText = parseInt(NET_sent_tot/(1024*1024*1024*1024)) + "T";
	}
}

//////////////////////////////////////////////////////////////////////////////////////
// NetLib ActiveX component
//////////////////////////////////////////////////////////////////////////////////////

// Register NetLib ActiveX component
function RegisterNetLib() {
	var classRoot = regRoot + "\\Software\\Classes\\NET_Gadget.NetworkInformation\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + dllCLSID + "\\";

	try{
		oShell.RegWrite(classRoot,"NET_Gadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(classRoot + "CLSID\\", dllCLSID, "REG_SZ");
		oShell.RegWrite(clsidRoot, "NET_Gadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\", "mscoree.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel", "Both", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Class", "NET_Gadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Assembly", "NetLib, Version=1.0.2588.9125, Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\RuntimeVersion", "v2.0.50727", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\CodeBase", "file:///" + gadgetPath.replace(charbackslash, "/") + "/netlib.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\Class", "NET_Gadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\Assembly", "NetLib, Version=1.0.2588.9125, Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\RuntimeVersion", "v2.0.50727", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\CodeBase", "file:///" + gadgetPath.replace(charbackslash, "/") + "/netlib.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\", "NET_Gadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "", "REG_SZ");
	} catch(err) {}
}

// Unregister NetLib ActiveX component
function UnregisterNetLib() {
	var classRoot = regRoot + "\\Software\\Classes\\NET_Gadget.NetworkInformation\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + dllCLSID + "\\";

	try{		
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\");
		oShell.RegDelete(clsidRoot + "ProgId\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\1.0.2588.9125\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\");
		oShell.RegDelete(clsidRoot);
		oShell.RegDelete(classRoot + "CLSID\\");
		oShell.RegDelete(classRoot);
	} catch(err) {}
}

// Try to register the DLL
function ActiveNetLib(root) {
	regRoot = root;

	try{
		RegisterNetLib();
		NetLib = new ActiveXObject("NET_Gadget.NetworkInformation");
	} catch(err) {
		NetLib = null;
		UnregisterNetLib();
		return false;
	}
	return true;
}
